

local MALORNE_HARNESS = "MalorneHarness"

local Options = {
	BaseStat='STA',

	derivedStats = {
		[MALORNE_HARNESS] = function()
			local eq = CatPoints.EquippedSets[MALORNE_HARNESS] or 0
			return eq
		end,
		Idol = function()
			return CatPoints:GetIdol()
		end,
		Health = function()
			return UnitHealthMax('player')
		end,
		Armor = function()
			return UnitArmor('player')
		end,
		HpPerStamina = function()
			local _,race = UnitRace('player')
			if(race == 'Tauren') then
				return 10.5
			else
				return 10
			end
		end,
		ArmorMultiplier = function(player)
			return 5.0*(1 + 0.1*player.ThickHide/3)
		end
	},
}

function Options:display()
	return true
end

function Options:applyBonus(bonuses, considerSet)
	local relevant = nil
	local s = self:new({})
	if(#bonuses == 0) then
		relevant = {}
	end

	local sotf = (1+s.SurvivaloftheFittest*.01)

	setmetatable(bonuses, {__index = function(_, name) if(relevant) then relevant[name]=true end return 0 end})

	local SetBonuses = {}
	setmetatable(SetBonuses, {__index = function(_, name) return 0 end})

	if(considerSet) then
		CatPoints:ConsiderSet(s, MALORNE_HARNESS, bonuses, SetBonuses, 4, 'ARMOR_BONUS', 1500)
	end

	s.Health = s.Health +bonuses.HEALTH+bonuses.STA*sotf*1.25*(1 + .2*s.HeartoftheWild/5)*s.HpPerStamina

	s.Armor = s.Armor + 2*bonuses.AGI*sotf+bonuses.BASE_ARMOR*s.ArmorMultiplier+bonuses.ARMOR_BONUS+SetBonuses.ARMOR_BONUS

	if(bonuses.Idol and bonuses.Idol ~= 0) then
		s.Idol = bonuses.Idol
	end
	return s,relevant
end


function Options:calculate()
	return (self.Health/(1-CatPoints:MitigationFromArmor(self.Armor)))/100
end


local Player = CatPoints:CreateTable("BearEff", Options)