
--[[
This file is used for offline testing of the calculation.

Update the values here to match the current stats you are
trying to calculate.
]]

local EOL = '\n'

function dummy(...)
	local t = {...}
	if(#t > 10) then
		error("too many args to function dummy")
	end
	return function() return t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8],t[9],t[10] end
end

function GCR(rating)
	local n= _G.CR
	if(not n) then
		return 0
	else
		n = rawget(n, rating)
		if(not n) then
			return 0
		end
	end
	return n
end

function setglobals(t)
	local mt = {
		__index = function(n, name)
			if(t[name]) then
				local value = t[name]
				if(type(value) == "function") then
					return(value())
				end
				return t[name]
			else
				return dummy(0,0,0,0,0,0,0,0,0,0)
			end
		end
	}
	setmetatable(_G, mt)
end

function prettyPrint(t, indent, call)
	if(not indent) then
		indent=""
	end
	if(type(t)=='table') then
		local str ="{"..EOL
		for k,v in pairs(t) do
			if(type(v)~='function' and k ~='parent' and k ~= 'relevant') then
				if(k=='derivedStats') then
					str = str.."{"..EOL
					for m, n in pairs(v) do
						str=str..indent.."   "..m.." = "..t[m]..","..EOL
					end
					str=str..indent.." }"
				else
					str=str..indent.." "..k.." = "..prettyPrint(v, indent.." ")..","..EOL
				end
			end
		end
		return str..indent.."}"
	else
		return tostring(t)
	end
end
--[[
local Stats = {
	CR_WEAPON_SKILL=10,
	CR_HIT_MELEE = 142,
	CR_HASTE_MELEE=10,
	AttackPower = 2500,
	CritChance = 30,
	WeaponDamage = 5,
	UnitHealthMax=15000,
	UnitRace='Tauren',
	UnitArmor=26500,
	UnitDefense=70,
	CR_CRIT_TAKEN_MELEE=60,
	DodgeChance = .3305,
	Level=70,
	Talents =
	{
		{name="SavageFury", rank= 2},
		{name="Ferocity", rank= 5},
		{name="ShreddingAttacks", rank= 2},
		{name="PredatoryInstincts", rank= 5},
		{name="Naturalist", rank= 5},
		{name="HeartoftheWild", rank= 5},
		{name="SurvivaloftheFittest", rank= 3},
		{name="OmenofClarity", rank= 1},
		{name="ThickHide", rank= 3},
	},
}
]]


ChatFrame1=
{
	AddMessage = function(self, ...) print(...) end
}


local function print(x, ...)
	if(type(x)=="table") then
		for k,v in pairs(x) do
			io.write(k.." = "..tostring(v).." ")
		end
	else
			io.write((x or "nil").." ")
	end
	if(#{...} > 0 ) then
		print(...)
	end
	io.write('\n')
end


local Bonuses =
{
	['Malorne Harness']=0
}


local Libs =
{
	["ItemBonusLib-1.0"] = {
		GetBonus = function(self, name)
			--print("looking up bonus "..name)
			return Bonuses[name]
		end
	},
	["AceAddon-2.0"] = {
		new = function()
			return {
				RegisterChatCommand = function() end,
				Print = function(self, ...) print(...) end,
				SecureHook = function() end,
				RegisterEvent = function() end,
				Hook = function() end
			}
		end,
	}
}
function AceLibrary(name)
	return Libs[name]
end


INVTYPE_WEAPON="INVTYPE_WEAPON"
INVTYPE_FINGER="INVTYPE_FINGER"
INVTYPE_TRINKET="INVTYPE_TRINKET"


CR_HIT_MELEE='CR_HIT_MELEE'
CR_CRIT='CR_CRIT'
CR_HASTE_MELEE='CR_HASTE_MELEE'
CR_WEAPON_SKILL='CR_WEAPON_SKILL'
CR_CRIT_TAKEN_MELEE='CR_CRIT_TAKEN_MELEE'

function GetInventoryItemLink()
	return nil
end
function GetNumTalentTabs()
	return 0
end

function GetNumTalents()
	return 0--#Stats.Talents
end

function GetTalentInfo(t, i)

	local talent = Stats.Talents[i]
	return talent.name, nil, nil, nil, talent.rank
end


--[[
function GetInventorySlotInfo()
	return nil
end

function GetInventoryItemLink()
	return nil
end


function UnitDamage()
	return 0,0,0,0,Stats.WeaponDamage
end

function UnitAttackPower()
	return Stats.AttackPower, 0, 0
end

function GetCritChance()
	return Stats.CritChance
end

function GetCombatRating(rating)
	return Stats[rating]
end

function UnitRace()
	return Stats.UnitRace
end
function UnitArmor()
	return Stats.UnitArmor
end

function UnitDefense()
	return 350, Stats.UnitDefense
end

function GetDodgeChance()
	return Stats.DodgeChance
end

function UnitLevel()
	return Stats.Level
end

function UnitHealthMax()
	return Stats.UnitHealthMax
end
]]
require('CatPoints')

--require('EffectiveHealth')
--require('Tank')

CatPoints:OnEnable(true)

--CatPoints:Equivalence('CatDPS-2.3')
--CatPoints:Equivalence('BearEff')
--print(CatPoints.Modifiers['BearEff']:calculate())

--[[
print(prettyPrint(CatPoints.Modifiers['CatDPS-2.3']))
print(prettyPrint(CatPoints.Modifiers['CatDPS-2.3']:CalcDPS(Enemy)))
print(prettyPrint(CatPoints.Modifiers['CatDPS-2.3']:applyBonus({bobo=1},true)))
print(prettyPrint(CatPoints.Modifiers['CatDPS-2.3']))


print(prettyPrint(CatPoints.Modifiers['BearEff']:compare({BASE_ARMOR=1})))
print(prettyPrint(CatPoints.Modifiers['BearEff']:compare({ARMOR_BONUS=1})))
print(prettyPrint(CatPoints.Modifiers['BearEff']:compare({AGI=1})))
print(prettyPrint(CatPoints.Modifiers['BearEff']:compare({STA=1})))
print(prettyPrint(CatPoints.Modifiers['BearEff']:compare({HEALTH=1})))]]

--CatPoints:Equivalence('Tank')

function TEST(condition, message)
	if(condition) then
		return true, "\tPassed"
	end
	return false, ("\tFailed: "..message)
end

local stacktrace = ""

local function saveStack(stuff)
	local trace = debug.traceback(stuff)
	local it = trace:gmatch("[^\r\n]+")
	stacktrace =it().."\n"
	it()
	it()
	it()
	for line in  it do stacktrace=stacktrace..line.."\n" end

end

function RunTests(tests, verbose, hidePass)
	print(format("\nRunning tests\n=============================="))

	local mt = getmetatable(_G)
	local failed = 0
	local total = 0
	local pass, message, success
	for k,v in pairs(tests) do
		total = total +1
		local n = format("%s%s", k, string.rep(" ",16-k:len()))
		--io.write()

		local info = debug.getinfo(v)
		local def = format(" %s:%d: ", info.source, info.linedefined)


		setmetatable(_G, mt)
		TraceStep = {}
		success,pass,message = xpcall(v, saveStack,verbose)

		if(success) then
			if(pass ) then
				if(not hidePass) then
					print(n..message)
				end
			else
				print(n..message..def)
				if(not verbose) then
					v(true)
				end
				failed = failed+1
			end
		else
			print(n.."\tException: "..(stacktrace or ""))

		end
	end

	print(format("==============================\n%d/%d tests passed\n", total-failed, total))
end

function PercentError(a,b)
	return math.abs(100*(a-b)/b)
end



Tests =
{
	BaseArmor = function()
		local expected = 1800
		local mit = CatPoints:MitigationFromArmor(expected)
		local actual = CatPoints:ArmorFromMitigation(mit)

		local error = PercentError(actual, expected)
		return TEST(error < 1, format("Expected %.2f and got %.2f (%.3f%% difference)", expected, actual,error))
	end,
	Penetration = function()
		local expected = 1800
		local penetration = 150
		local mit = CatPoints:MitigationFromArmor(expected-penetration)
		local actual = CatPoints:ArmorFromMitigation(mit, penetration)

		local error = PercentError(actual, expected)
		return TEST(error < 1, format("Expected %.2f and got %.2f (%.3f%% difference)", expected, actual,error))
	end,
}


if(not CatDPSTest) then
	SkipTests = true
	require('CatDPSTest')
	SkipTests = false
end




if(not SkipTests) then
	RunTests(Tests, false)
end



